diff --git a/gcc/analyzer/state-purge.cc b/gcc/analyzer/state-purge.cc
index 1371db904aa..be878036f08 100644
--- a/gcc/analyzer/state-purge.cc
+++ b/gcc/analyzer/state-purge.cc
@@ -1069,61 +749,19 @@ state_purge_per_decl::needed_at_point_p (const function_point &point) const
    Add an additional record showing which names are purged on entry
    to the supernode N.  */
 
-bool
-state_purge_annotator::add_node_annotations (graphviz_out *gv,
-					     const supernode &n,
-					     bool within_table) const
-{
-  if (m_map == nullptr)
-    return false;
-
-  if (within_table)
-    return false;
-
-  pretty_printer *pp = gv->get_pp ();
-
-   pp_printf (pp, "annotation_for_node_%i", n.m_index);
-   pp_printf (pp, " [shape=none,margin=0,style=filled,fillcolor=%s,label=\"",
-	      "lightblue");
-   pp_write_text_to_stream (pp);
-
-   /* Different in-edges mean different names need purging.
-      Determine which points to dump.  */
-   auto_vec<function_point> points;
-   if (n.entry_p () || n.m_returning_call)
-     points.safe_push (function_point::before_supernode (&n, nullptr));
-   else
-     for (auto inedge : n.m_preds)
-       points.safe_push (function_point::before_supernode (&n, inedge));
-   points.safe_push (function_point::after_supernode (&n));
-
-   for (auto & point : points)
-     {
-       point.print (pp, format (true));
-       pp_newline (pp);
-       print_needed (gv, point, false);
-       pp_newline (pp);
-     }
-
-   pp_string (pp, "\"];\n\n");
-   pp_flush (pp);
-   return false;
-}
-
-/* Print V to GV as a comma-separated list in braces, titling it with TITLE.
-   If WITHIN_TABLE is true, print it within a <TR>
+/* Print V to GV as a comma-separated list in braces within a <TR>,
+   titling it with TITLE.
 
    Subroutine of state_purge_annotator::print_needed.  */
 
 static void
 print_vec_of_names (graphviz_out *gv, const char *title,
-		    const auto_vec<tree> &v, bool within_table)
+		    const auto_vec<tree> &v)
 {
   pretty_printer *pp = gv->get_pp ();
   tree name;
   unsigned i;
-  if (within_table)
-    gv->begin_trtd ();
+  gv->begin_trtd ();
   pp_printf (pp, "%s: {", title);
   FOR_EACH_VEC_ELT (v, i, name)
     {
@@ -1132,54 +770,18 @@ print_vec_of_names (graphviz_out *gv, const char *title,
       pp_printf (pp, "%qE", name);
     }
   pp_printf (pp, "}");
-  if (within_table)
-    {
-      pp_write_text_as_html_like_dot_to_stream (pp);
-      gv->end_tdtr ();
-    }
+  pp_write_text_as_html_like_dot_to_stream (pp);
+  gv->end_tdtr ();
   pp_newline (pp);
 }
 
-/* Implementation of dot_annotator::add_stmt_annotations for
-   state_purge_annotator.
-
-   Add text showing which names are purged at STMT.  */
-
 void
-state_purge_annotator::add_stmt_annotations (graphviz_out *gv,
-					     const gimple *stmt,
-					     bool within_row) const
+state_purge_annotator::add_node_annotations (graphviz_out *gv,
+					     const supernode &snode) const
 {
-  if (within_row)
-    return;
-
   if (m_map == nullptr)
     return;
 
-  if (stmt->code == GIMPLE_PHI)
-    return;
-
-  pretty_printer *pp = gv->get_pp ();
-
-  pp_newline (pp);
-
-  const supernode *supernode = m_map->get_sg ().get_supernode_for_stmt (stmt);
-  unsigned int stmt_idx = supernode->get_stmt_index (stmt);
-  function_point before_stmt
-    (function_point::before_stmt (supernode, stmt_idx));
-
-  print_needed (gv, before_stmt, true);
-}
-
-/* Get the decls and SSA names needed and not-needed at POINT, and
-   print them to GV.
-   If WITHIN_TABLE is true, print them within <TR> elements.  */
-
-void
-state_purge_annotator::print_needed (graphviz_out *gv,
-				     const function_point &point,
-				     bool within_table) const
-{
   auto_vec<tree> needed;
   auto_vec<tree> not_needed;
   for (state_purge_map::ssa_iterator iter = m_map->begin_ssas ();
@@ -1188,9 +790,9 @@ state_purge_annotator::print_needed (graphviz_out *gv,
     {
       tree name = (*iter).first;
       state_purge_per_ssa_name *per_name_data = (*iter).second;
-      if (&per_name_data->get_function () == point.get_function ())
+      if (&per_name_data->get_function () == snode.get_function ())
 	{
-	  if (per_name_data->needed_at_point_p (point))
+	  if (per_name_data->needed_at_supernode_p (&snode))
 	    needed.safe_push (name);
 	  else
 	    not_needed.safe_push (name);
@@ -1202,17 +804,17 @@ state_purge_annotator::print_needed (graphviz_out *gv,
     {
       tree decl = (*iter).first;
       state_purge_per_decl *per_decl_data = (*iter).second;
-      if (&per_decl_data->get_function () == point.get_function ())
+      if (&per_decl_data->get_function () == snode.get_function ())
 	{
-	  if (per_decl_data->needed_at_point_p (point))
+	  if (per_decl_data->needed_at_supernode_p (&snode))
 	    needed.safe_push (decl);
 	  else
 	    not_needed.safe_push (decl);
 	}
     }
 
-  print_vec_of_names (gv, "needed here", needed, within_table);
-  print_vec_of_names (gv, "not needed here", not_needed, within_table);
+  print_vec_of_names (gv, "needed here", needed);
+  print_vec_of_names (gv, "not needed here", not_needed);
 }
 
 #endif /* #if ENABLE_ANALYZER */
diff --git a/gcc/analyzer/state-purge.h b/gcc/analyzer/state-purge.h
index 2bac564175c..6afcdcccbbb 100644
--- a/gcc/analyzer/state-purge.h
+++ b/gcc/analyzer/state-purge.h
@@ -21,53 +21,6 @@ along with GCC; see the file COPYING3.  If not see
 #ifndef GCC_ANALYZER_STATE_PURGE_H
 #define GCC_ANALYZER_STATE_PURGE_H
 
-/* Hash traits for function_point.  */
-
-template <> struct default_hash_traits<function_point>
-: public pod_hash_traits<function_point>
-{
-  static const bool empty_zero_p = false;
-};
-
-template <>
-inline hashval_t
-pod_hash_traits<function_point>::hash (value_type v)
-{
-  return v.hash ();
-}
-
-template <>
-inline bool
-pod_hash_traits<function_point>::equal (const value_type &existing,
-                                 const value_type &candidate)
-{
-  return existing == candidate;
-}
-template <>
-inline void
-pod_hash_traits<function_point>::mark_deleted (value_type &v)
-{
-  v = function_point::deleted ();
-}
-template <>
-inline void
-pod_hash_traits<function_point>::mark_empty (value_type &v)
-{
-  v = function_point::empty ();
-}
-template <>
-inline bool
-pod_hash_traits<function_point>::is_deleted (value_type v)
-{
-  return v.get_kind () == PK_DELETED;
-}
-template <>
-inline bool
-pod_hash_traits<function_point>::is_empty (value_type v)
-{
-  return v.get_kind () == PK_EMPTY;
-}
-
 namespace ana {
 
 /* The result of analyzing which decls and SSA names can be purged from state at
@@ -123,6 +76,10 @@ public:
   decl_iterator begin_decls () const { return m_decl_map.begin (); }
   decl_iterator end_decls () const { return m_decl_map.end (); }
 
+  void
+  on_duplicated_node (const supernode &old_snode,
+		      const supernode &new_snode);
+
 private:
   DISABLE_COPY_AND_ASSIGN (state_purge_map);
 
@@ -140,7 +97,7 @@ public:
   tree get_fndecl () const { return m_fun.decl; }
 
 protected:
-  typedef hash_set<function_point> point_set_t;
+  typedef hash_set<const supernode *> point_set_t;
 
   state_purge_per_tree (const function &fun)
   : m_fun (fun)
@@ -165,21 +122,27 @@ public:
 			    tree name,
 			    const function &fun);
 
-  bool needed_at_point_p (const function_point &point) const;
+  bool needed_at_supernode_p (const supernode *snode) const;
+
+  void
+  on_duplicated_node (const supernode &old_snode,
+		      const supernode &new_snode);
 
 private:
+#if 0
   static function_point before_use_stmt (const state_purge_map &map,
 					 const gimple *use_stmt);
+#endif
 
-  void add_to_worklist (const function_point &point,
-			auto_vec<function_point> *worklist,
+  void add_to_worklist (const supernode &node,
+			auto_vec<const supernode *> *worklist,
 			logger *logger);
 
-  void process_point (const function_point &point,
-		      auto_vec<function_point> *worklist,
-		      const state_purge_map &map);
+  void process_supernode (const supernode &node,
+			  auto_vec<const supernode *> *worklist,
+			  const state_purge_map &map);
 
-  point_set_t m_points_needing_name;
+  point_set_t m_snodes_needing_name;
   tree m_name;
 };
 
@@ -197,34 +160,38 @@ public:
 			tree decl,
 			const function &fun);
 
-  bool needed_at_point_p (const function_point &point) const;
+  bool needed_at_supernode_p (const supernode *snode) const;
 
-  void add_needed_at (const function_point &point);
-  void add_pointed_to_at (const function_point &point);
+  void add_needed_at (const supernode &snode);
+  void add_pointed_to_at (const supernode &snode);
   void process_worklists (const state_purge_map &map,
 			  region_model_manager *mgr);
 
+  void
+  on_duplicated_node (const supernode &old_snode,
+		      const supernode &new_snode);
+
 private:
-  static function_point before_use_stmt (const state_purge_map &map,
+  static const supernode * before_use_stmt (const state_purge_map &map,
 					 const gimple *use_stmt);
 
-  void add_to_worklist (const function_point &point,
-			auto_vec<function_point> *worklist,
+  void add_to_worklist (const supernode &node,
+			auto_vec<const supernode *> *worklist,
 			point_set_t *seen,
 			logger *logger);
 
-  void process_point_backwards (const function_point &point,
-				auto_vec<function_point> *worklist,
-				point_set_t *seen,
-				const state_purge_map &map,
-				const region_model &model);
-  void process_point_forwards (const function_point &point,
-			       auto_vec<function_point> *worklist,
-			       point_set_t *seen,
-			       const state_purge_map &map);
-
-  point_set_t m_points_needing_decl;
-  point_set_t m_points_taking_address;
+  void process_supernode_backwards (const supernode &snode,
+				    auto_vec<const supernode *> *worklist,
+				    point_set_t *seen,
+				    const state_purge_map &map,
+				    const region_model &model);
+  void process_supernode_forwards (const supernode &snode,
+				   auto_vec<const supernode *> *worklist,
+				   point_set_t *seen,
+				   const state_purge_map &map);
+
+  point_set_t m_snodes_needing_decl;
+  point_set_t m_snodes_taking_address;
   tree m_decl;
 };
 
@@ -236,18 +203,11 @@ class state_purge_annotator : public dot_annotator
 public:
   state_purge_annotator (const state_purge_map *map) : m_map (map) {}
 
-  bool add_node_annotations (graphviz_out *gv, const supernode &n, bool)
-    const final override;
-
-  void add_stmt_annotations (graphviz_out *gv, const gimple *stmt,
-			     bool within_row)
-    const final override;
+  void
+  add_node_annotations (graphviz_out *gv,
+			const supernode &n) const final override;
 
 private:
-  void print_needed (graphviz_out *gv,
-		     const function_point &point,
-		     bool within_table) const;
-
   const state_purge_map *m_map;
 };
 
diff --git a/gcc/analyzer/store.cc b/gcc/analyzer/store.cc
index b354f9b6387..49661f4904c 100644
--- a/gcc/analyzer/store.cc
+++ b/gcc/analyzer/store.cc
@@ -3578,6 +3578,26 @@ store::canonicalize (store_manager *mgr)
     }
 }
 
+static bool
+needs_loop_replay_fixup_p (const svalue &sval)
+{
+  struct my_visitor : public visitor
+  {
+    my_visitor () : m_found_widening (false) {}
+
+    void
+    visit_widening_svalue (const widening_svalue *) final override
+    {
+      m_found_widening = true;
+    }
+
+    bool m_found_widening;
+  } v;
+
+  sval.accept (&v);
+  return v.m_found_widening;
+}
+
 /* Subroutine for use by exploded_path::feasible_p.
 
    We need to deal with state differences between:
@@ -3618,7 +3638,7 @@ store::loop_replay_fixup (const store *other_store,
 	{
 	  const binding_key *key = (*bind_iter).m_key;
 	  const svalue *sval = (*bind_iter).m_sval;
-	  if (sval->get_kind () == SK_WIDENING)
+	  if (needs_loop_replay_fixup_p (*sval))
 	    {
 	      binding_cluster *this_cluster
 		= get_or_create_cluster (*mgr->get_store_manager (),
diff --git a/gcc/analyzer/supergraph-fixup-locations.cc b/gcc/analyzer/supergraph-fixup-locations.cc
new file mode 100644
index 00000000000..3c2c327d2b0
--- /dev/null
+++ b/gcc/analyzer/supergraph-fixup-locations.cc
@@ -0,0 +1,139 @@
+/* Fixing up location_t values of supernodes.
+   Copyright (C) 2025 Free Software Foundation, Inc.
+   Contributed by David Malcolm <dmalcolm@redhat.com>.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+#define INCLUDE_DEQUE
+#define INCLUDE_SET
+#include "analyzer/common.h"
+
+#include "timevar.h"
+#include "gimple-pretty-print.h"
+#include "ordered-hash-map.h"
+#include "options.h"
+#include "cgraph.h"
+#include "cfg.h"
+#include "digraph.h"
+#include "tree-cfg.h"
+#include "tree-dfa.h"
+#include "cfganal.h"
+#include "except.h"
+#include "gcc-rich-location.h"
+#include "sbitmap.h"
+
+#include "analyzer/supergraph.h"
+#include "analyzer/analyzer-logging.h"
+#include "analyzer/supergraph-manipulation.h"
+#include "analyzer/region-model.h"
+
+#if ENABLE_ANALYZER
+
+namespace ana {
+
+namespace {
+
+class location_fixer
+{
+public:
+  location_fixer (supergraph &sg,
+		  ana::logger *logger)
+  : m_sg (sg),
+    m_logger (logger),
+    m_stats ()
+  {
+    for (auto node : sg.m_nodes)
+      if (node->m_loc == UNKNOWN_LOCATION)
+	m_worklist.ensure_node_queued (node, logger);
+  }
+
+  /* High level ops.  */
+
+  supernode *
+  pop_next_node_in_queue ()
+  {
+    return m_worklist.pop ();
+  }
+
+  void
+  consider_node (supernode *node)
+  {
+    m_stats.m_num_iterations++;
+
+    log_nesting_level sentinel (m_logger, "considering SN: %i", node->m_id);
+
+    /* Already have a location for this node.  */
+    if (useful_location_p (node->m_loc))
+      return;
+
+    /* For snodes with UNKNOWN_LOCATION with a single in-edge, try to
+       propagate the location from it.  */
+    if (node->m_preds.length () == 1)
+      {
+	auto in_edge = node->m_preds[0];
+	if (useful_location_p (in_edge->m_src->m_loc))
+	  {
+	    node->m_loc = in_edge->m_src->m_loc;
+	    m_stats.m_num_copies++;
+	    if (m_logger)
+	      m_logger->log ("copying location 0x%lx from SN %i to SN %i",
+			     node->m_loc,
+			     in_edge->m_src->m_id, node->m_id);
+	    for (auto out_edge : node->m_succs)
+	      m_worklist.ensure_node_queued (out_edge->m_dest, m_logger);
+	  }
+      }
+  }
+
+private:
+  supergraph &m_sg;
+  state_purge_map *m_purge_map;
+  supergraph_manipulation::worklist m_worklist;
+  ana::logger *m_logger;
+  struct stats
+  {
+    stats () = default;
+
+    void log (ana::logger &logger)
+    {
+      logger.log ("# iterations taken: " HOST_SIZE_T_PRINT_UNSIGNED,
+		  (fmt_size_t)m_num_iterations);
+      logger.log ("# locations copied: " HOST_SIZE_T_PRINT_UNSIGNED,
+		  (fmt_size_t)m_num_copies);
+    }
+
+    size_t m_num_iterations;
+    size_t m_num_copies;
+
+  } m_stats;
+};
+
+} // anonymous namespace
+
+void
+supergraph::fixup_locations (logger *logger)
+{
+  LOG_SCOPE (logger);
+
+  location_fixer opt (*this, logger);
+  while (supernode *node = opt.pop_next_node_in_queue ())
+    opt.consider_node (node);
+}
+
+} // namespace ana
+
+#endif /* #if ENABLE_ANALYZER */
diff --git a/gcc/analyzer/supergraph-manipulation.h b/gcc/analyzer/supergraph-manipulation.h
new file mode 100644
index 00000000000..35592027097
--- /dev/null
+++ b/gcc/analyzer/supergraph-manipulation.h
@@ -0,0 +1,73 @@
+/* Classes for manipulating the supergraph.
+   Copyright (C) 2025 Free Software Foundation, Inc.
+   Contributed by David Malcolm <dmalcolm@redhat.com>.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+#ifndef GCC_ANALYZER_SUPERGRAPH_MANIPULATION_H
+#define GCC_ANALYZER_SUPERGRAPH_MANIPULATION_H
+
+#if ENABLE_ANALYZER
+
+namespace ana {
+namespace supergraph_manipulation {
+
+class worklist
+{
+public:
+  worklist ()
+  : m_indices ()
+  {
+    bitmap_clear (m_indices);
+  }
+
+  void ensure_node_queued (supernode *node, ana::logger *logger)
+  {
+    if (bitmap_bit_p (m_indices, node->m_id))
+      return; // already in queue
+    if (logger)
+      logger->log ("queued SN: %i", node->m_id);
+    m_queue.push_back (node);
+    bitmap_set_bit (m_indices, node->m_id);
+  }
+
+  supernode *pop ()
+  {
+    if (m_queue.empty ())
+      return nullptr;
+    supernode *node = m_queue.front ();
+    m_queue.pop_front ();
+    bitmap_clear_bit (m_indices, node->m_id);
+    return node;
+  }
+
+private:
+  // The queue
+  std::deque<supernode *> m_queue;
+
+  /* Indices of all nodes in the queue, so
+     we can lazily add them in constant time.  */
+  auto_bitmap m_indices;
+};
+
+
+} // namespace ana::supergraph_manipulation
+} // namespace ana
+
+#endif /* #if ENABLE_ANALYZER */
+
+#endif /* GCC_ANALYZER_SUPERGRAPH_MANIPULATION_H */
diff --git a/gcc/analyzer/supergraph-simplify.cc b/gcc/analyzer/supergraph-simplify.cc
new file mode 100644
index 00000000000..ef3272f7193
--- /dev/null
+++ b/gcc/analyzer/supergraph-simplify.cc
@@ -0,0 +1,330 @@
+/* Simplifying the supergraph.
+   Copyright (C) 2025 Free Software Foundation, Inc.
+   Contributed by David Malcolm <dmalcolm@redhat.com>.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify it
+under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 3, or (at your option)
+any later version.
+
+GCC is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING3.  If not see
+<http://www.gnu.org/licenses/>.  */
+
+#define INCLUDE_DEQUE
+#define INCLUDE_SET
+#include "analyzer/common.h"
+
+#include "timevar.h"
+#include "gimple-pretty-print.h"
+#include "ordered-hash-map.h"
+#include "options.h"
+#include "cgraph.h"
+#include "cfg.h"
+#include "digraph.h"
+#include "tree-cfg.h"
+#include "tree-dfa.h"
+#include "cfganal.h"
+#include "except.h"
+#include "gcc-rich-location.h"
+#include "sbitmap.h"
+
+#include "analyzer/supergraph.h"
+#include "analyzer/analyzer-logging.h"
+#include "analyzer/supergraph-manipulation.h"
+#include "analyzer/region-model.h"
+#include "analyzer/bar-chart.h"
+
+#if ENABLE_ANALYZER
+
+namespace ana {
+
+namespace {
+
+/* A class for tracking a set of simplifications to a supergraph.
+   supergraph.m_nodes and supergraph.m_edges may contain deleted object
+   during the lifetime of this class; they are removed at the end.  */
+
+class simplifier
+{
+public:
+  simplifier (supergraph &sg,
+	      ana::logger *logger)
+  : m_sg (sg),
+    m_nodes_to_remove (),
+    m_edges_to_remove (),
+    m_logger (logger),
+    m_stats ()
+  {
+    for (auto node : sg.m_nodes)
+      m_worklist.ensure_node_queued (node, logger);
+  }
+
+  ~simplifier ()
+  {
+    // Remove nodes from m_sg.m_nodes and delete them
+    m_sg.delete_nodes (m_nodes_to_remove);
+
+    // Remove edges from m_sg.m_edges and delete them
+    {
+      unsigned read_index, write_index;
+      superedge **elem_ptr;
+      VEC_ORDERED_REMOVE_IF (m_sg.m_edges, read_index, write_index, elem_ptr,
+			     edge_to_be_removed_p (*elem_ptr));
+      for (auto iter : m_edges_to_remove)
+	delete iter;
+    }
+
+    if (m_logger)
+      {
+	log_nesting_level sentinel (m_logger, "stats");
+	m_stats.log (*m_logger);
+      }
+  }
+
+  /* Manipulations: logged, and refreshing the worklist.  */
+
+  void
+  set_edge_dest (superedge *edge, supernode *new_dest)
+  {
+    if (edge->m_dest == new_dest)
+      return;
+    log_nesting_level sentinel
+      (m_logger, "updating edge dest: SN: %i -> SN: {%i, %i}",
+       edge->m_src->m_id,
+       edge->m_dest->m_id,
+       new_dest->m_id);
+    m_worklist.ensure_node_queued (edge->m_src, m_logger);
+    m_worklist.ensure_node_queued (edge->m_dest, m_logger);
+    m_worklist.ensure_node_queued (new_dest, m_logger);
+
+    edge->set_dest (new_dest);
+
+    m_stats.m_num_set_edge_dest++;
+  }
+
+  void
+  remove_node (supernode *node)
+  {
+    log_nesting_level sentinel
+      (m_logger, "removing node: SN: %i", node->m_id);
+    for (auto in_edge : node->m_preds)
+      remove_edge (in_edge);
+    for (auto out_edge : node->m_succs)
+      remove_edge (out_edge);
+    m_nodes_to_remove.insert (node);
+    m_stats.m_num_remove_node++;
+  }
+
+  void
+  remove_edge (superedge *edge)
+  {
+    log_nesting_level sentinel
+      (m_logger, "removing edge dest: SN: %i -> SN: %i",
+       edge->m_src->m_id,
+       edge->m_dest->m_id);
+    gcc_assert (!edge->preserve_p ());
+
+    m_worklist.ensure_node_queued (edge->m_src, m_logger);
+    m_worklist.ensure_node_queued (edge->m_dest, m_logger);
+
+    edge->m_src->remove_out_edge (edge);
+    edge->m_dest->remove_in_edge (edge);
+
+    m_edges_to_remove.insert (edge);
+
+    m_stats.m_num_remove_edge++;
+  }
+
+  /* High level ops.  */
+
+  supernode *
+  pop_next_node_in_queue ()
+  {
+    return m_worklist.pop ();
+  }
+
+  void
+  consider_node (supernode *node)
+  {
+    m_stats.m_num_iterations++;
+
+    log_nesting_level sentinel (m_logger, "considering SN: %i", node->m_id);
+
+    /* Eliminate nodes with no in-edges that aren't function entry nodes.  */
+    if (node->m_preds.length () == 0
+	&& !node->entry_p ())
+      {
+	log_nesting_level s2 (m_logger, "no in-edges");
+	remove_node (node);
+	return;
+      }
+
+    /* Handle nodes with a single out-edge.  */
+    if (node->m_succs.length () == 1)
+      if (consider_single_out_edge (node, node->m_succs[0]))
+	return;
+  }
+
+  bool
+  consider_single_out_edge (supernode *node,
+			    superedge *single_out_edge)
+  {
+    if (node->preserve_p ())
+      {
+	log_nesting_level s3
+	  (m_logger,
+	   "node has preserve_p flag; preserving");
+	return false;
+      }
+    if (single_out_edge->preserve_p ())
+      {
+	log_nesting_level s3
+	  (m_logger,
+	   "edge has preserve_p flag; preserving");
+	return false;
+      }
+
+    /* Is the single out-edge a no-op?  */
+    if (!single_out_edge->get_op ())
+      {
+	/* If the node doesn't add useful location information, we can
+	   redirect all in-edges to the node to point at the outedge's dst.  */
+	log_nesting_level s2 (m_logger,
+			      "single outedge is no-op (to SN: %i)",
+			      node->m_succs[0]->m_dest->m_id);
+	bool redirect = false;
+	if (node->m_loc == UNKNOWN_LOCATION)
+	  {
+	    log_nesting_level s3
+	      (m_logger,
+	       "node is at UNKNOWN_LOCATION; redirecting in-edges");
+	    redirect = true;
+	  }
+	else if (node->m_loc == single_out_edge->m_dest->m_loc)
+	  {
+	    log_nesting_level s3
+	      (m_logger,
+	       "node has same location as successor; redirecting in-edges");
+	    redirect = true;
+	  }
+
+	if (redirect)
+	  {
+	    for (auto in_edge : node->m_preds)
+	      set_edge_dest (in_edge, single_out_edge->m_dest);
+	    return true;
+	  }
+
+	return false;
+      }
+
+    gcc_assert (single_out_edge->get_op ());
+
+    return false;
+  }
+
+private:
+  bool edge_to_be_removed_p (superedge *edge)
+  {
+    return m_edges_to_remove.find (edge) != m_edges_to_remove.end ();
+  }
+
+  supergraph &m_sg;
+  supergraph_manipulation::worklist m_worklist;
+  std::set<supernode *> m_nodes_to_remove;
+  std::set<superedge *> m_edges_to_remove;
+  ana::logger *m_logger;
+  struct stats
+  {
+    stats () = default;
+
+    void log (ana::logger &logger)
+    {
+      logger.log ("# iterations taken: " HOST_SIZE_T_PRINT_UNSIGNED,
+		  (fmt_size_t)m_num_iterations);
+      logger.log ("# nodes removed: " HOST_SIZE_T_PRINT_UNSIGNED,
+		  (fmt_size_t)m_num_remove_node);
+      logger.log ("# edges removed: " HOST_SIZE_T_PRINT_UNSIGNED,
+		  (fmt_size_t)m_num_remove_edge);
+      logger.log ("# set_edge_dest: " HOST_SIZE_T_PRINT_UNSIGNED,
+		  (fmt_size_t)m_num_set_edge_dest);
+    }
+
+    size_t m_num_iterations;
+    size_t m_num_remove_node;
+    size_t m_num_remove_edge;
+    size_t m_num_set_edge_dest;
+
+  } m_stats;
+};
+
+} // anonymous namespace
+
+void
+supergraph::log_stats (logger *logger) const
+{
+  if (!logger)
+    return;
+
+  logger->log ("# nodes: %u", m_nodes.length ());
+  logger->log ("# edges: %u", m_edges.length ());
+
+  /* Show per-function bar charts of supernodes per function.  */
+  {
+    bar_chart snodes_per_function;
+    logger->log ("snodes per function:");
+
+    cgraph_node *cgnode;
+    FOR_EACH_FUNCTION_WITH_GIMPLE_BODY (cgnode)
+      {
+	function *fn = cgnode->get_fun ();
+
+	int snodes_for_this_function = 0;
+	for (auto node : m_nodes)
+	  if (node->get_function () == fn)
+	    ++snodes_for_this_function;
+
+	pretty_printer pp;
+	pp_format_decoder (&pp) = default_tree_printer;
+	pp_printf (&pp, "%qD", fn->decl);
+	snodes_per_function.add_item (pp_formatted_text (&pp),
+				      snodes_for_this_function);
+      }
+
+    snodes_per_function.print (logger->get_printer ());
+  }
+}
+
+void
+supergraph::simplify (logger *logger)
+{
+  LOG_SCOPE (logger);
+
+  {
+    log_nesting_level sentinel (logger, "before simplification:");
+    log_stats (logger);
+  }
+
+  {
+    simplifier opt (*this, logger);
+    while (supernode *node = opt.pop_next_node_in_queue ())
+      opt.consider_node (node);
+  }
+
+  {
+    log_nesting_level sentinel (logger, "after simplification");
+    log_stats (logger);
+  }
+}
+
+} // namespace ana
+
+#endif /* #if ENABLE_ANALYZER */
